package callserver;

import hsm.HsmReply;

import java.net.MalformedURLException;
import java.rmi.*;


import client.FormPainter;
import client.ServerEventProvider;
import client.ServerQuery;
import server.Bank;

import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;

public class ServerReply implements ControlledObject {
	private char command;
	private int cardN;
	private int dispenseAmount;
	private int phoneNumber;
	private String reply;
	Bank bank; 
	
	
	
	
	/**
	 * @unimod.action.descr  
	 */
	public void z0(StateMachineContext context) {
		command = ServerQuery.ServerInfo.command;
		cardN = ServerQuery.ServerInfo.cardN;
		dispenseAmount = ServerQuery.ServerInfo.dispenseAmount;
		phoneNumber = ServerQuery.ServerInfo.phoneNumber;
		switch(command){
		case 'A': ClientEventProvider.notify(ClientEventProvider.E21); break;
		case 'B': ClientEventProvider.notify(ClientEventProvider.E22); break;
		case 'D': ClientEventProvider.notify(ClientEventProvider.E23); break;
		case 'P': ClientEventProvider.notify(ClientEventProvider.E24); break;
		}
	}

	/**
	 * @unimod.action.descr 
	 */
	public void z1(StateMachineContext context) {
		
		try{
			bank = (Bank)Naming.lookup("rmi://localhost/bank");
		}catch(NotBoundException e){
			System.out.println("Not bound");
			e.printStackTrace();
		}catch(MalformedURLException e){
			System.out.println("MalformedURL");		
			e.printStackTrace();
		}catch(RemoteException e){
			System.out.println("RemoteException");			
			e.printStackTrace();
		};
		   

		
		reply = HsmReply.reply;
	}
	
	/**
	 * @unimod.action.descr  
	 */
	public void z2(StateMachineContext context) {
		try{
			ServerQuery.ServerInfo.balance = bank.getBalance(cardN);
			reply = ServerEventProvider.E12;
			FormPainter.endOperationMessage = "operEndOK";
		}catch(RemoteException e){
			reply = ServerEventProvider.E17;
			FormPainter.endOperationMessage = "operEndNoConnect";
		}
		ClientEventProvider.notify(ClientEventProvider.E25);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z3(StateMachineContext context) {
		try{
			if(bank.dispenseMoney(cardN, dispenseAmount)){
				reply = ServerEventProvider.E13;
				FormPainter.endOperationMessage = "operEndOK";
			}
			else {
				reply = ServerEventProvider.E14;
				FormPainter.endOperationMessage = "operEndNoMoney";
			}
		}catch(RemoteException e){
			reply = ServerEventProvider.E17;
			FormPainter.endOperationMessage = "operEndNoConnect";
		}
		ClientEventProvider.notify(ClientEventProvider.E25);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z4(StateMachineContext context) {
		try{
			int ans = bank.makePayment(cardN, dispenseAmount, phoneNumber);
			if (ans == -2){
				reply = ServerEventProvider.E16;
				FormPainter.endOperationMessage = "operEndNoPhoneNumber";				
			}
			if (ans == -1){
				reply = ServerEventProvider.E14;
				FormPainter.endOperationMessage = "operEndNoMoney";
			}
			if (ans == 1){
				reply = ServerEventProvider.E15;
				FormPainter.endOperationMessage = "operEndOK";
			}
		}catch(RemoteException e){
			reply = ServerEventProvider.E17;
			FormPainter.endOperationMessage = "operEndNoConnect";

		}
		ClientEventProvider.notify(ClientEventProvider.E25);
		
	}
	/**
	 * @unimod.action.descr  
	 */
	public void z5(StateMachineContext context) {
		ClientEventProvider.notify("temp");
		ClientEventProvider.notify(reply);
	}

}
