package client; 

import java.awt.event.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;


public class TForm extends JFrame implements ActionListener{
    /**
	 * 
	 */
	private static final long serialVersionUID = 6429657139792187715L;
	private ModelEngine engine = null;
    public Locale locale = new Locale("ru", "RU");
    ResourceBundle rb = ResourceBundle.getBundle("MessagesBundle", locale);
    public PanelMain panelMain; 
    
	TForm(ModelEngine engine){
		
		super("ATM");
		this.setResizable(false);
		this.engine = engine;
		
		panelMain = new PanelMain(this);
		panelMain.showState("init", null, "");
		setContentPane(panelMain);
		setBounds(100, 100, 640, 480);
		setLocation(100, 100);
		setVisible(true);
	}
	
	public void notify(String event){
		engine.getEventManager().handle(new Event(event), StateMachineContextImpl.create());
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == panelMain.button1)
			notify(HumanEventProvider.E1);
		if(e.getSource() == panelMain.button2)
			notify(HumanEventProvider.E2);
		if(e.getSource() == panelMain.button3)
			notify(HumanEventProvider.E3);
		if(e.getSource() == panelMain.button4)
			notify(HumanEventProvider.E4);

		if(e.getSource() == panelMain.button_Ins)
			notify(HardwareEventProvider.E5);
		if(e.getSource() == panelMain.button_BackCard){
			notify(HardwareEventProvider.E6);
		}

		if(e.getSource() == panelMain.button_CheckOut)
			notify(HardwareEventProvider.E9);
		if(e.getSource() == panelMain.button_MoneyOut)
			notify(HardwareEventProvider.E8);
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////
class CurrentState{
	public String state;
	public String mess;
	public String adv;
	public CurrentState(String state, String stateN, String serverState, String mess, String adv){
		this.state = state;
		this.mess = mess;
		this.adv = adv;
	}
}


class CurrentButton{
	public String sb1;
	public String sb2;
	public String sb3;
	public String sb4;
	public CurrentButton( String st1, String st2, String st3, String st4){
		this.sb1 = st1;
		this.sb2 = st2;
		this.sb3 = st3;
		this.sb4 = st4;
	}
}


class PanelMain extends Panel{
	private static final long serialVersionUID = -3564330398896150391L;
	
	CurrentButton curbtn = new CurrentButton("", "", "", "");
	CurrentState curstate = new CurrentState("", "", "", "", "");
	public TForm f;

    protected Font messageFont = new Font("Arial", Font.BOLD, 20);
    
	private ImageIcon img = new ImageIcon(TForm.class.getResource("Img/background.gif"));
	private JLabel img_Label = new JLabel(img);
	
	public JButton button1 = new JButton("");;
	public JButton button2 = new JButton("");;
	public JButton button3 = new JButton("");;
	public JButton button4 = new JButton("");;
	
	public JLabel buttonLabel1 = new JLabel("");
	public JLabel buttonLabel2 = new JLabel("");
	public JLabel buttonLabel3 = new JLabel("", JLabel.RIGHT);
	public JLabel buttonLabel4 = new JLabel("", JLabel.RIGHT);

	public JLabel label_Mess = new JLabel("");
	
	public JButton button_Ins = new JButton("^");
	
	public JTextField edit_Pin = new JTextField("");
    public JTextField edit_CardNumber = new JTextField("");
    public JTextField edit_PhoneNumber = new JTextField("");

    
	public JLabel label_Sum = new JLabel("");
	public JLabel label_PhoneNumber = new JLabel("");
    
    
	public JButton button_BackCard = new JButton("v");
	
	public JTextField edit_Sum = new JTextField("");

	public JButton button_MoneyOut = new JButton("v");
	public ImageIcon imgMoneyOut = new ImageIcon(TForm.class.getResource("Img/money.gif"));
	public JLabel label_ImgMoneyOut = new JLabel(imgMoneyOut);
	

	
	public JButton button_CheckOut = new JButton("v");
	public ImageIcon imgCheckOut = new ImageIcon(TForm.class.getResource("Img/receipt.gif"));
	public JLabel label_ImgCheckOut = new JLabel(imgCheckOut);
		
	
	public void setRB(Locale l){
		f.rb = ResourceBundle.getBundle("MessagesBundle", l);
	}
	void ladd(JLabel l){
		add(l);
		l.setFont(messageFont);
		l.setHorizontalAlignment(0);
		l.setForeground(Color.yellow);
	}
	
	void l2add(JLabel l){
		add(l);
		buttonLabel1.setVisible(true);
		l.setForeground(Color.green);
	}
	
	void badd(JButton b){
		add(b);
		b.setVisible(true);
		b.addActionListener(f);
		setComponentZOrder(b, 1);
	}

	PanelMain(TForm f){
		
		this.f = f;
		ladd(label_Mess);
		
		l2add(label_Sum);
		l2add(label_PhoneNumber);

		badd(button_Ins);

		add(edit_CardNumber);
		add(edit_Pin);
		add(edit_PhoneNumber);
		
		badd(button_BackCard);
		
		add(edit_Sum);
		
		badd(button_MoneyOut);
		add(label_ImgMoneyOut);
		
		badd(button_CheckOut);
		add(label_ImgCheckOut);
		
	//main
		badd(button1);
		badd(button2);
		badd(button3);
		badd(button4);
		
		l2add(buttonLabel1);
		l2add(buttonLabel2);
		l2add(buttonLabel3);
		l2add(buttonLabel4);
				
		add(img_Label);
   	img_Label.setVisible(true);
    	
    	
	}
	
	public void markButton(String sb1, String sb2, String sb3, String sb4){
		buttonLabel1.setText(f.rb.getString(sb1)); 
		buttonLabel2.setText(f.rb.getString(sb2)); 
		buttonLabel3.setText(f.rb.getString(sb3)); 
		buttonLabel4.setText(f.rb.getString(sb4)); 
		curbtn.sb1 = sb1;
		curbtn.sb2 = sb2;
		curbtn.sb3 = sb3;
		curbtn.sb4 = sb4;
	}
	
	public void showState(String state, String mess, String adv){
		curstate.state = state;
		
		label_Sum.setText(f.rb.getString("sum"));
		label_PhoneNumber.setText(f.rb.getString("number"));

		curstate.mess = mess;
		curstate.adv = adv;
	
		
		if(mess != null) label_Mess.setText(f.rb.getString(mess) + adv);
		if (state == "card return") label_Mess.setText(f.rb.getString(adv) + "<br>" + f.rb.getString(mess));
		if (state == "enter pin" && adv!="") label_Mess.setText(f.rb.getString(adv));

		label_Mess.setVisible(mess != "");
		
 
		button_Ins.setVisible(state == "welcome" );

		edit_CardNumber.setVisible(state == "welcome");
		edit_Pin.setVisible(state == "enter pin");
		
		edit_PhoneNumber.setVisible(state == "enter phoneNumber" || state == "check payment");
		edit_PhoneNumber.setEditable(state != "check payment");
		label_PhoneNumber.setVisible(state == "enter phoneNumber" || state == "check payment");
		
		button_BackCard.setVisible(state == "card return");
		
		edit_Sum.setVisible(state == "enter sum" || state == "check payment");
		edit_Sum.setEditable(state != "check payment");
		label_Sum.setVisible(state == "enter sum" || state == "check payment");
		
		button_MoneyOut.setVisible(state == "money out");
		label_ImgMoneyOut.setVisible(state == "money out");
		
		button_CheckOut.setVisible(state == "print");
		label_ImgCheckOut.setVisible(state == "print");
		
	}
	
	public void doLayout(){
		img_Label.setBounds(0, 0, 640, 480);

		button1.setBounds(20, 335, 90, 30);
		button2.setBounds(20, 380, 90, 30);
		button3.setBounds(520, 335, 90, 30);
		button4.setBounds(520, 380, 90, 30);
		
		buttonLabel1.setBounds(150, 335, 160, 30);
		buttonLabel2.setBounds(150, 380, 160, 30);
		buttonLabel3.setBounds(320, 335, 160, 30);
		buttonLabel4.setBounds(320, 380, 160, 30);
		
		label_Mess.setBounds(150, 200, 330, 150);

		button_Ins.setBounds(400, 330, 50, 20);		
		edit_CardNumber.setBounds(230, 330, 150, 20);
		edit_Pin.setBounds(270, 370, 100, 20);

		label_PhoneNumber.setBounds(220, 290, 70, 40);		
		edit_PhoneNumber.setBounds(270, 300, 100, 20);
		
		button_BackCard.setBounds(400, 330, 50, 20);

		label_Sum.setBounds(220, 320, 80, 40);
		edit_Sum.setBounds(280, 330, 80, 20);

		button_MoneyOut.setBounds(40, 230, 50, 15);
		label_ImgMoneyOut.setBounds(0, 0, 640, 480);

		button_CheckOut.setBounds(535, 110, 50, 15);
		label_ImgCheckOut.setBounds(0, 0, 640, 480);
	}
}
