package hsm;

import java.rmi.*;
import java.net.*;


import server.Bank;
import callserver.ClientEventProvider;
import client.FormPainter;
import client.HardwareEventProvider;
import client.ServerQuery;
import client.ServerEventProvider;


import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;

public class HsmReply implements ControlledObject {
	private int cardN;
	private int cardPIN;
	public static String reply;
	Bank bank;

	/**
	 * @unimod.action.descr  
	 */
	public void z0(StateMachineContext context) {
		cardN = ServerQuery.ServerInfo.cardN;
		cardPIN = ServerQuery.ServerInfo.cardPIN;
	}

	/**
	 * @unimod.action.descr  PIN
	 */
	public void z1(StateMachineContext context) {
		try{
			bank = (Bank)Naming.lookup("rmi://localhost/bank");
		}catch(NotBoundException e){
			System.out.println("Not bound");
			e.printStackTrace();
		}catch(MalformedURLException e){
			System.out.println("MalformedURL");		
			e.printStackTrace();
		}catch(RemoteException e){
			System.out.println("RemoteException");			
			e.printStackTrace();
		};
		   
		try{
			int ans = bank.checkCard(cardN, cardPIN);
			if (ans == 1) {
				reply = ServerEventProvider.E10;
				FormPainter.goodbyeMessage = "goodbyeOK";
			}
			if (ans == -1){
				reply = ServerEventProvider.E11;
			}			
			if (ans == -2){
				reply = HardwareEventProvider.E7;
				FormPainter.goodbyeMessage = "goodbyeWrongCard";
			}
			
		}catch(RemoteException e){
			reply = ServerEventProvider.E17;
		}
		ClientEventProvider.notify(ClientEventProvider.E20);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z2(StateMachineContext context) {
		ClientEventProvider.notify(ClientEventProvider.E20);
		ClientEventProvider.notify(ClientEventProvider.E25);
	}
}
