package model;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.commons.logging.LogFactory;
import org.apache.log4j.xml.DOMConfigurator;

import com.evelopers.common.exception.CommonException;
import com.evelopers.unimod.adapter.standalone.Run;
import com.evelopers.unimod.core.stateworks.Model;
import com.evelopers.unimod.debug.ExceptionHandlerImpl;
import com.evelopers.unimod.runtime.EventProcessorListener;
import com.evelopers.unimod.runtime.ExceptionHandler;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.interpretation.InterpretationHelper;
import com.evelopers.unimod.runtime.logger.SimpleLogger;
import com.evelopers.unimod.transform.xml.XMLToModel;

public class Start {
	
    private static final String MAIN_AUTOMATA_XML = "model/AClient.xml";
    

	public static void main(String[] args) {

        try {
        	DOMConfigurator.configure(Run.class.getResource("log4j.xml"));
        	InterpretationHelper helper = InterpretationHelper.getInstance();
        	Model model = XMLToModel.loadAndCompile(
        			new FileInputStream(MAIN_AUTOMATA_XML)
        		);        					
        	ModelEngine engine = helper.createStandAloneModelEngine(model, 
        			true);
        	EventProcessorListener logger = new SimpleLogger(
        			LogFactory.getLog(Run.class));
            engine.getEventProcessor().addEventProcessorListener(logger);
            ExceptionHandler eh = new ExceptionHandlerImpl();
            engine.getEventProcessor().addExceptionHandler(eh);
            engine.start();
        } catch(CommonException e) {
        	e.printStackTrace();
        } catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
    }

}
