package server;

import java.io.*;
import java.rmi.RemoteException;
import server.Bank;


public class BankImpl implements Bank{
//	private final String fileName = BankImpl.class.getResource("Bank.dat").getFile();
	int dataSize;
	int[][] data;
	int[] numbers;
	int numbersSize;
	
	BankImpl(){
		try{
			loadFromFile();
		}catch(Exception e){
			System.out.println("-------------");
			e.printStackTrace();
			System.out.println("-------------");
		}
	}
	
	public void loadFromFile()throws RemoteException{
		try{
			BufferedReader f = new BufferedReader(new InputStreamReader(new FileInputStream("data/Cards.dat"), "windows-1251"));
			dataSize = Integer.parseInt(f.readLine());
			data = new int[dataSize][3];
			for(int i = 0; i < dataSize; i++){
				data[i][0] = Integer.parseInt(f.readLine());
				data[i][1] = Integer.parseInt(f.readLine());
				data[i][2] = Integer.parseInt(f.readLine());
			}
			f.close();
			f = new BufferedReader(new InputStreamReader(new FileInputStream("data/Numbers.dat"), "windows-1251"));
			numbersSize = Integer.parseInt(f.readLine());
			numbers = new int[numbersSize];
			for(int i = 0; i < numbersSize; i++){
				numbers[i] = Integer.parseInt(f.readLine());
			}
			f.close();
			
		}catch(Exception e){
			System.out.println("* - - = Base load error = - - *");
		}
	}

	public void saveToFile()throws RemoteException{
		try{
			BufferedWriter f = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("data/Cards.dat"), "windows-1251"));
			f.write("" + dataSize + '\n');
			for(int i = 0; i < dataSize; i++){
				f.write("" + data[i][0] + '\n');
				f.write("" + data[i][1] + '\n');
				f.write("" + data[i][2] + '\n');
			}
			f.close();
		}catch(Exception e){
			System.out.println("!!![ERROR]----Failed to save database----!!!");
		}
	}

	public int checkCard(int N, int pin)throws RemoteException{
		
		loadFromFile();
		
		int res = -2;
		
		System.out.println("Auth");
		System.out.println("*********");
		System.out.println("Card Number: '" + N + "'");
		System.out.println("PIN: '" + pin + "'");
		for(int i = 0; i < dataSize; i++){
			if(data[i][0] == N){
				res = -1;
				if(data[i][1] == pin){
					res = 1;
					break;
				}
			}
		}
		return res;
	}

	public int getBalance(int N)throws RemoteException{

		loadFromFile();
		
		System.out.println("Balance inquiry");
		System.out.println("*********");
		System.out.println("Card Number: '" + N + "'");		

		int balance = -1;

		for(int i = 0; i < dataSize; i++)
			if(data[i][0] == N){
				balance = data[i][2];
				break;
			}
		System.out.println("Commit");
		System.out.println("");
		return balance;
	}

	public boolean dispenseMoney(int N, int sum)throws RemoteException{

		loadFromFile();
		
		if (sum <= 0) return false;

		
		boolean res = false;

		System.out.println("Dispense");
		System.out.println("*********");
		System.out.println("Card Number: '" + N + "'");
		System.out.println("Sum: '" + sum + "'");

		
		for(int i = 0; i < dataSize; i++)
			if(data[i][0] == N){
				System.out.println("Amount available: '" + data[i][2]+ "'");
				System.out.println("Commit");
				System.out.println("");


				if(data[i][2] >= sum){
					res = true;
					data[i][2] -= sum;
					saveToFile();
				}
				break;
			}
		System.out.println(res);
		return res;
	}

	public int makePayment(int N, int sum, int phoneNumber)throws RemoteException{

		loadFromFile();
		
		int res = -2;
		
		System.out.println("Payment");
		System.out.println("*********");
		System.out.println("Card Number: '" + N + "'");
		System.out.println("Sum: '" + sum + "'");
		System.out.println();


		
		for(int i = 0; i < numbersSize; i++)
			if(numbers[i] == phoneNumber){
				res = -1;
				break;
			}
		
		if (res == -2) return res;
		
		for(int i = 0; i < dataSize; i++)
			if(data[i][0] == N){
				if(data[i][2] >= sum){					
					res = 1;

					System.out.println("Amount available: '" + data[i][2]+ "'");
					System.out.println("Commit");
					System.out.println("");

					data[i][2] -= sum;
					saveToFile();
				}
				break;
			}
		System.out.println(res);
		return res;
	}	
}

